<template>
  <div class="table-page">
    <div class="table-page-content">
      <div class="left-tree">
        <tree-side
          ref="treeSide"
          :dataLoading="treeLoading"
          :default-expand-all="false"
          :defaultProps="defaultProps"
          :tabList="['组织路段树']"
          :treeData="treeData"
          isDeselect
          @currentChange="currentChange"
        ></tree-side>
      </div>
      <div class="right-table">
        <div class="full-page bg">
          <div class="search-box">
            <div class="search-box-combination">
              <div class="search-box-label">预警时间：</div>
              <div>
                <el-date-picker
                  v-model="params.querys[3].value"
                  end-placeholder="预警时间"
                  range-separator="至"
                  start-placeholder="预警时间"
                  style="width: 280px"
                  type="datetimerange"
                  value-format="yyyy-MM-dd HH:mm:ss"
                  @change="datePickerChange"
                >
                </el-date-picker>
              </div>
              <div class="search-box-label" style="min-width: 100px">是否完善数据：</div>
              <div class="">
                <el-select
                  v-model="params.querys[4].value"
                  filterable
                  placeholder="请选择是否完善数据"
                  style="width: 120px"
                  @change="statusPickerChange"
                >
                  <el-option
                    v-for="item in statusList"
                    :key="item.value"
                    :label="item.name"
                    :value="item.value"
                  >
                  </el-option>
                </el-select>
              </div>
              <SearchCommon :optionList="optionList" @search="handleSearch" />
            </div>
          </div>
          <div class="main-table-container">
            <div class="table-container" style="padding: 20px">
              <div ref="btnPanel" class="btn-box">
                <el-button
                  :disabled="!isAddShow"
                  class="btn btn-plus"
                  icon="el-icon-plus"
                  size="small"
                  type="primary"
                  @click="changePage('EditAddPage', {roadId: treeItem.id})"
                >
                  添加
                </el-button>
                <el-button
                  :disabled="!currentDataDel.length"
                  class="btn btn-delete"
                  icon="el-icon-delete"
                  plain
                  size="small"
                  type="danger"
                  @click="handleDelete()"
                >
                  删除
                </el-button>
                <el-button
                  :loading="downloadLoading"
                  class="btn btn-plus"
                  icon="el-icon-download"
                  size="small"
                  type="success"
                  @click="exportData"
                >导出
                </el-button>
              </div>
              <div ref="tableRef" class="table-content">
                <el-table
                  ref="multipleSelection"
                  v-loading="tableLoading"
                  :data="tableData"
                  :max-height="tableMaxHeight"
                  border
                  class="table-list"
                  element-loading-background="rgba(10 ,38 ,61, 0.9)"
                  row-key="id"
                  stripe
                  @select="handleSelection"
                  @selection-change="handleSelectionChange"
                  @row-dblclick="handleDbClick"
                >
                  <el-table-column align="center" type="selection" width="55" />
                  <el-table-column
                    align="center"
                    label="序号"
                    type="index"
                    width="60"
                  />
                  <el-table-column
                    :formatter="({regionalName}) => regionalName || '-'"
                    align="center"
                    label="所属区域"
                    min-width="80"
                    prop="regionalName"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({warningName}) => warningName || '-'"
                    align="center"
                    label="预警名称"
                    min-width="80"
                    prop="warningName"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="
                      ({warningLevel}) =>
                        dictionaryEscape('yxjc-yjdj', warningLevel + '')
                    "
                    align="center"
                    label="预警等级"
                    min-width="80"
                    prop="warningLevel"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="
                      ({warningValue}) =>
                        dictionaryEscape('yjlxdm', warningValue + '')
                    "
                    align="center"
                    label="预警灾害类型"
                    min-width="100"
                    prop="warningValue"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({warnRange}) => warnRange || '-'"
                    align="center"
                    label="可能受影响区县"
                    min-width="100"
                    prop="warnRange"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({roadName}) => roadName || '-'"
                    align="center"
                    label="可能受影响路段"
                    min-width="100"
                    prop="roadName"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    :formatter="({warningTime}) => warningTime || '-'"
                    align="center"
                    label="预警时间"
                    min-width="120"
                    prop="warningTime"
                    show-overflow-tooltip
                  />
                  <el-table-column
                    align="center"
                    label="是否完善数据"
                    min-width="100"
                    prop="pubStatus"
                  >
                    <template slot-scope="scope">
                      <div
                        :style="{
                                              color: scope.row.pubStatus ? '#67c23a' : '#e6a23c'
                                            }"
                      >
                        {{ scope.row.pubStatus ? '已处理' : '未处理' }}
                      </div>
                    </template>
                  </el-table-column>
                  <el-table-column
                    align="center"
                    label="操作"
                    min-width="120"
                    show-overflow-tooltip
                  >
                    <template v-slot="{row}">
                      <el-link
                        :underline="false"
                        type="primary"
                        @click="handleDbClick(row)"
                      >
                        编辑
                      </el-link>
                      <el-link
                        :underline="false"
                        type="primary"
                        @click="handleDetailPage(row)"
                      >
                        详情
                      </el-link>
                      <el-link
                        :underline="false"
                        type="danger"
                        @click="handleDelete(row)"
                      >
                        删除
                      </el-link>
                    </template>
                  </el-table-column>
                </el-table>
                <pagination
                  ref="paginationPanel"
                  :pageResult="params.pageBean"
                  style="margin-top: 10px"
                  @size-change="handleSizeChange"
                  @current-change="handleCurrentChange"
                />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {refineRequestBody, setQueryValue} from '@/utils/requestWrappers'
import pagination from '@/components/SuperPagination/index.vue'
import {TableMixin} from '@/mixins/tableMixin'
import treeSide from '@/components/treeSide/index.vue'
import SearchCommon from '@/components/SearchCommon/index.vue'
import {exportFile, tableData, tableDelete} from '@/api/patrolAndRescue/operationalMonitoring/calledPartyAnswer'
import PubSub from 'pubsub-js'
import {dictionaryEscape, getDictionaryByCode} from '@/utils/dictionary'
import moment from 'moment'
import {getTree} from '@/api/tree'

export default {
  name: 'TablePage',
  components: {
    pagination,
    treeSide,
    SearchCommon
  },
  mixins: [TableMixin],
  data() {
    return {
      statusList: [
        {
          name: '全部',
          value: ''
        },
        {
          name: '已处理',
          value: 1
        },
        {
          name: '未处理',
          value: 0
        }
      ],
      isAddShow: false,
      pubSub: null,
      tableMaxHeight: '600px',
      loading: false,
      treeLoading: true,
      tableLoading: false,
      treeData: [], //左边树
      defaultProps: {
        children: 'children',
        label: 'name'
      },
      tableData: [],
      currentDataDel: [],
      optionList: [
        {
          title: '预警等级',
          prop: 'warningLevel',
          type: 'select',
          option: getDictionaryByCode('yxjc-yjdj'),
          multiple: true,
          default: true
        },
        {
          title: '预警灾害类型',
          prop: 'warning_value_',
          type: 'select',
          option: getDictionaryByCode('yjlxdm'),
          multiple: true
        }
      ],
      params: {
        pageBean: {pageSize: 20, page: 1, total: 0},
        querys: [
          {operation: 'IN', property: 'roadId'},
          {
            group: 'quick',
            operation: 'IN',
            relation: 'OR',
            property: 'warningLevel'
          },
          {
            group: 'quick',
            operation: 'IN',
            relation: 'OR',
            property: 'warning_value_'
          },
          {
            operation: 'BETWEEN',
            property: 'warning_time_',
            value: [
              moment().subtract(1, 'month')
                .startOf('month')
                .format('YYYY-MM-DD HH:mm:ss'),
              moment()
                .endOf('month')
                .format('YYYY-MM-DD HH:mm:ss')
            ]
          },
          {
            operation: 'IN',
            relation: 'AND',
            property: 'PUB_STATUS_',
            value: ''
          }
        ],
        sorter: [
          {
            property: 'warningTime',
            direction: 'DESC'
          }
        ]
      },
      treeDialog: false, // 科目信息弹层
      treeItemId: '', // 树形目录id
      treeItem: {}, // 树形节点选中对象
      isShowPopover: false,
      downloadLoading: false,
      uploadLoading: false
    }
  },
  created() {
    // 获取树形目录-
    this.getOrgTreeData(treeData => {
      // 回调中默认选中第一项并将其id作为参数请求表格
      this.treeItem = treeData[0] || {}
      let array = []
      if (this.treeItem.children.length > 0) {
        array = this.extractIds(this.treeItem)
      }
      this.$nextTick(_ => {
        this.$refs.treeSide?.setCurrentKey(treeData[0]?.id) //通过 $refs 获取treeSide组件引用，并调用 setCurrentKey方法设置当前选中的树节点。
        this.$refs.treeSide?.expandHandle(true, 2)
      })
      setQueryValue(this.params, 'roadId', array)
      this.loadData() //加载表格数据
    })
  },
  mounted() {
    this.pubSub = PubSub.subscribe('TablePage', (_, data) => {
      switch (data.type) {
        case 'add':
          this.params.pageBean.page = 1
          this.loadData()
          break
        case 'edit':
          this.loadData()
          break
      }
    })
  },
  methods: {
    getDictionaryByCode,
    dictionaryEscape,
    // 状态切换
    statusPickerChange(val) {
      setQueryValue(this.params, 'PUB_STATUS_', val)
      this.params.pageBean.page = 1
      this.loadData()
    },
    extractIds(node) {
      let ids = []
      // 如果当前节点有 children，则递归提取
      if (node.children) {
        ids = node.children.map(child => child.id) // 提取当前节点的 id
        // 递归提取子节点的 id
        node.children.forEach(child => {
          ids = ids.concat(this.extractIds(child))
        })
      }
      return ids
    },
    // 时间范围切换
    datePickerChange(val) {
      setQueryValue(this.params, 'warning_time_', val)
      this.params.pageBean.page = 1
      this.loadData()
    },
    // 获取公司树-异步方法，用于从后端获取树形数据
    async getOrgTreeData(callback) {
      try {
        this.treeLoading = true //开始加载时显示加载状态
        let {value} = await getTree() // 调用 API 获取树形数据
        this.treeData = [value]
      } finally {
        this.treeLoading = false // 无论成功或失败，都关闭加载状态
        callback && callback(this.treeData) // 如果提供了回调函数，则调用它并传入树形数据
      }
    },
    transformTreeData(data) {
      return {
        name: data.name,
        id: data.id,
        children: data.children.reduce((acc, child) => {
          acc.push({
            id: child.id,
            name: child.name,
            path: child.path,
            children: child.roadList.map(road => ({
              id: road.id,
              name: road.name,
              path: road.path
            }))
          })
          return acc
        }, [])
      }
    },
    //左边树节点
    currentChange(nodeItem) {
      if (nodeItem.id === '1766017468444450816') {
        this.isAddShow = false
        setQueryValue(this.params, 'roadId ', this.extractIds(nodeItem))
      } else if (nodeItem.children && nodeItem.children.length > 0) {
        this.isAddShow = false
        const array = nodeItem.children.map(item => item.id)
        setQueryValue(this.params, 'roadId ', array)
      } else {
        this.isAddShow = true
        setQueryValue(this.params, 'roadId ', [nodeItem?.id] || [])
      }
      // if (nodeItem.children && nodeItem.children.length > 0) {
      //   this.isAddShow = false
      //   const array = nodeItem.children.map(item => item.id)
      //   setQueryValue(this.params, 'roadId ', array)
      // } else {
      //   this.isAddShow = true
      //   setQueryValue(this.params, 'roadId ', [nodeItem?.id] || [])
      // }
      this.treeItem = nodeItem || {}
      this.calcTableHeight(500)
      PubSub.publish('TreeItemSelected', {
        id: nodeItem?.id || '',
        name: nodeItem?.name || '',
        path: nodeItem?.path || ''
      })
      this.params.pageBean.page = 1
      this.loadData()
    },
    //获取数据
    async loadData() {
      this.tableLoading = true
      const {total = 0, rows = []} = await tableData(
        refineRequestBody(this.params)
      )
      this.params.pageBean.total = total
      this.tableData = rows.map(row => ({
        ...row,
        roadName: row.roadName || this.treeItem.name
      }))
      this.tableLoading = false
    },

    async exportData() {
      this.downloadLoading = true
      try {
        await exportFile(refineRequestBody(this.params))
        this.$message.success(`数据导出成功`)
      } finally {
        this.downloadLoading = false
      }
    },
    // 删除
    handleDelete(row) {
      this.clickTimer = true
      this.$confirm('确定删除选中预警叫应吗？', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(async () => {
          let ids = row ? row.id : this.currentDataDel.join()
          let {state, message} = await tableDelete(ids)
          if (state) {
            this.$message.success(`预警叫应删除成功`)
            const {page, pageSize, total} = this.params.pageBean
            const totalPages = Math.ceil(total / pageSize) // 计算总页数
            if (totalPages > 1 && page === totalPages) {
              if (this.tableData.length === 1) {
                // 当前页只有一条数据
                this.params.pageBean.page -= 1 // 返回前一页
              }
            }
            await this.loadData()
          } else {
            this.$message.error(message)
          }
        })
        .catch(_ => _)
    },

    //修改
    handleDbClick(row) {
      if (this.clickTimer) return (this.clickTimer = false)
      const payload = {
        ...row,
        roadName: row.roadName || this.treeItem.name
      }
      this.changePage('EditAddPage', payload)
    },

    // 改变页面
    changePage(pageName = '', row = {}) {
      if (!pageName) return
      const payload = row.id
        ? row
        : {
          roadId: this.treeItem.id,
          roadName: this.treeItem.name,
          path: this.treeItem.path
        }
      this.$emit(
        'changePage',
        pageName,
        _ => {
          PubSub.publish(pageName, payload)
        },
        row.id ? '编辑' : '添加'
      )
    }
  },
  beforeDestroy() {
    // 在组件销毁之前 清除订阅消息
    PubSub.unsubscribe(this.pubSub)
  }
}
</script>

<style lang="scss" scoped></style>
